/* avl.h */

#ifndef AVL_H
#define AVL_H

#define F 0
#define V 1

#include "defs.h"
#include "ponto_evento.h"

typedef union {
  double chave_d;
  reta* chave_r;
} union_chave;

class info {
 public:
  union_chave chave;
  ponto_evento *p;
};

class celula {
 public:
  celula *esq, *dir, *pai;
  short int bal;
  cor c;
  info i;
};

typedef celula *celula_pt;

class avl {
 protected:
  celula_pt raiz, livre;
  int achou, desbalanceado;
  void rotacao_esq (celula_pt *pai);
  void rotacao_dir (celula_pt *pai);
  void balanco_dir (celula_pt *p);
  void balanco_esq (celula_pt *p);
  virtual int compara_igual_chave (info a, celula_pt b);
  virtual int compara_menor_chave (info a, celula_pt b);
  void imprime_aux(celula_pt pai, int espaco);
  void delete_aux(celula_pt *q, celula_pt *r);
  void real_insere(celula_pt *pai, info x);
  void real_delete(celula_pt *pai, info x);
public:
  avl();
  celula_pt avl_busca (info x);
  celula_pt avl_minimo ();
  celula_pt avl_maximo ();
  void imprime_arvore();
  void avl_insere(info x);
  void avl_delete(info x);
  int vazia();
};

#endif
