#include <stdlib.h>
#include <stdio.h>
#include "avl.h"
#include "event_queue.h"
#include "funcoes.h"

celula_pt event_queue::busca(ponto_evento *p) {
  info i;
  i.p = p;
  i.chave.chave_d = p->a.x;

  return avl_busca(i);
}


celula_pt event_queue::busca_exata(ponto_evento *p) {
  celula_pt pt = raiz;
  info x;

  x.p = p;
  x.chave.chave_d = p->a.x;

  while (pt != NULL && (!compara_igual_chave(x, pt) || pt->i.p->a.y != p->a.y)) //x&&(pt->i.chave != x.chave))
    if (compara_menor_chave(x, pt) || compara_igual_chave(x, pt)) // x.chave < pt->i.chave)
      pt = pt->esq;
    else // no precisa dessa comparao if (x.chave > pt->i.chave)
      pt = pt->dir;
  return pt;
}


void event_queue::insert(ponto_evento *p) {
  info i;

  i.chave.chave_d = p->a.x;
  i.p = new ponto_evento(p);
  
  avl_insere(i);
}

ponto_evento* event_queue::minimo() {
  celula_pt aux;
  ponto_evento* p;

  aux = avl_minimo();

  if (aux) {
    p = aux->i.p;
    real_delete(&raiz, aux->i);
    return p;
  }
  else 
    return NULL;
}


// supe que j existe ponto evento p que seja igual ao pnovo
// e verifica apenas se os ponto evento segmento j esto incluindo, seno os inclue
void event_queue::verifica_interseccao(ponto_evento *p, ponto_evento *pnovo) {
  ponto_evento_segmento* pseg_aux;
  int existe_seg1, existe_seg2;

  existe_seg1 = existe_seg2 = 0;
  
  for (pseg_aux = p->pseg; pseg_aux; pseg_aux = pseg_aux->prox) {
    if (pseg_aux->s == pnovo->pseg->s && pseg_aux->t == pnovo->pseg->t)
      existe_seg1 = 1;
    else if (pseg_aux->s == pnovo->pseg->prox->s && pseg_aux->t == pnovo->pseg->prox->t)
      existe_seg2 = 1;
  }
    
  if (!existe_seg1) p->adiciona_pes(pnovo->pseg->t, pnovo->pseg->s);
  if (!existe_seg2) p->adiciona_pes(pnovo->pseg->prox->t, pnovo->pseg->prox->s);
}

void event_queue::remove(ponto_evento *p) {
  info i;

  i.chave.chave_d = p->a.x;
  i.p = new ponto_evento(p);

  avl_delete(i);
}
