/****************************************************************************
 * funcoes.h                                                                *
 * Neste arquivo implementamos algumas funes genricas bsicas            *
 ****************************************************************************/

#ifndef FUNCOES_AUXILIARES
#define FUNCOES_AUXILIARES

#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include "defs.h"
#include <pthread.h>
#define _REENTRANT


/* Guarda a informao de uma interseco. D para fazer uma lista ligada de
 * interseces */
typedef struct inter {
    reta * A, * B;
    ponto ponto_interseccao;
//    int tipo;
    int passo;
    struct inter * proximo;
} interseccao;

double Area2(ponto * a, ponto * b, ponto * c);

double Left(ponto * a, ponto * b, ponto * c);

double LeftOn(ponto * a, ponto * b, ponto * c);

double Collinear(ponto * a, ponto * b, ponto * c);

/* Esta funo verifica se duas retas (a, b) e (c, d) tem interseco */
int interseccao_reta(reta * A, reta * B);

ponto * ponto_interseccao_reta(reta * r1, reta * r2, ponto * p);

int le_pontos(FILE * Entrada, reta * retas);


/* Agora vamos definir as variveis e funes da interface grfica */


/* Agora ns precisamos da estrutura de dados que ser passada entre os
 * processos. A idia bsica  ter um conjunto de interseces e um conjunto
 * de coloraes de retas a cada iterao */

typedef struct col {
    reta * r;
    double cor[3];
    int passo;
    struct col * proximo;
} coloracao_reta;

typedef struct varre {
    double x;
    int passo;
    struct varre * proximo;
} varredura;

typedef struct {
    interseccao * i; /* Lista de interseces encontradas */
    coloracao_reta * c; /* Retas sendo comparadas */
    coloracao_reta * m; /* Lista de retas mortas */
    varredura * v; /* Lista ligada com a linha de varredura */

    int acabou;

    /* Variveis de condio */
    pthread_cond_t espera; /* Varivel que o algoritmo deve esperar */
    pthread_cond_t novo_passo; /* Varivel que o algoritmo deve
                                  sinalizar a cada passo */
    pthread_mutex_t mutex; /* Nosso mutex para a transferncia de dados. 
			     * necessrio inicializar */
    pthread_t algoritmo; /* thread que vai guardar o algoritmo */
} dados_interprocessos;

extern dados_interprocessos buffer; /* Nossa varivel de comunicao */

#include "interface.h"

#endif

