#include <stdio.h>
#include <stdlib.h>
#include "funcoes.h"
#include "ponto_evento.h"

ponto_evento::ponto_evento(ponto p, tipo_ponto t, reta* s) {
  a = p;
  if (!(pseg = new ponto_evento_segmento)) {
    fprintf(stderr, "Erro ao alocar memria para ponto evento: %s\n", strerror(errno));
    exit(1);
  }
    
  pseg->t = t;
  pseg->s = s;
  pseg->prox = NULL;
}

ponto_evento::ponto_evento(ponto p) {
  a = p;
  pseg = NULL;
}

ponto_evento::ponto_evento(ponto_evento* p) {
  ponto_evento_segmento *pseg_aux, *pseg_novo, *pseg_velho;

  a = p->a;

  // verifica se  valido o ponteiro, pois pode ser um ponto evento apenas com o ponto
  if (p->pseg) {
    if (!(pseg = new ponto_evento_segmento)) {
      fprintf(stderr, "Erro ao alocar memria para ponto evento: %s\n", strerror(errno));
      exit(1);
    }
    pseg->t = p->pseg->t;
    pseg->s = p->pseg->s;
  }

  pseg_velho = pseg;
  
  if (p->pseg->prox) 
    for(pseg_aux = p->pseg->prox; pseg_aux; pseg_aux = pseg_aux->prox) {
      if (!(pseg_novo = new ponto_evento_segmento)) {
	fprintf(stderr, "Erro ao alocar memria para ponto evento: %s\n", strerror(errno));
	exit(1);
      }
      pseg_novo->t = pseg_aux->t;
      pseg_novo->s = pseg_aux->s;
      pseg_velho->prox = pseg_novo;
      pseg_velho = pseg_novo;
    } 
  pseg_velho->prox = NULL;
}

void ponto_evento::adiciona_pes(tipo_ponto t, reta* s) {
  ponto_evento_segmento* pseg_aux = pseg; 

  pseg = new ponto_evento_segmento;
  pseg->prox = pseg_aux;
  pseg->t = t;
  pseg->s = s;
}

int ponto_evento::ha_interseccao() {
  return (pseg->prox != NULL);
}

