#include <stdlib.h>
#include <stdio.h>
#include "avl.h"
#include "sweep_line.h"
#include "funcoes.h"

celula_pt sweep_line::busca(reta *r, ponto_evento *p) {
  info i;
  i.p = p;
  i.chave.chave_r = r;

  return avl_busca(i);
}

void sweep_line::insert(reta *r, ponto_evento *p, int interseccao) {
  info i;

  i.p = p; 
  i.chave.chave_r = r;

  if (interseccao) {
    reta vertical;
    ponto pto;

    // Preparativos para uso da Reta Vertical
    vertical.a.y = menory;
    vertical.b.y = maiory;
    
    vertical.a.x = vertical.b.x = i.p->a.x;
  
    ponto_interseccao_reta(&vertical, r, &pto);
    // Fim Reta Vertical
    
    // ajusta o ponto
    i.p->a = pto;
  }

  avl_insere(i);
}

void sweep_line::remove(reta* r, ponto_evento *p) {
  info i;

  i.chave.chave_r = r;
  i.p = p;

  avl_delete(i);
}

int sweep_line::compara_igual_chave (info a, celula_pt b) {
  return (int) Collinear(&(reta(b)->a), &(reta(b)->b), &(a.p->a));
}

int sweep_line::compara_menor_chave (info a, celula_pt b) {
    return (int) !LeftOn(&(reta(b)->a), &(reta(b)->b), &(a.p->a));
}
